local explosions = {} -- holds the list of explosions
-- generate a sprite
function pixelf(x, y, r, g, b, a)
    x = x - radius
    y = y - radius
    cr = x^2 + y^2
    if cr < radius^2 then
        r=255
        g=206
        b=105
        a=255 * cr/radius^2
    else
        r=0
        g=0
        b=0
        a=255
    end
    return r, g, b, 255-a
end
-- generate a particle system
function boom(image)
    local p
    local system = {}
    p = love.graphics.newParticleSystem(image,476)
    p:setEmissionRate(1000)
    p:setLifetime(0.134228)
    p:setParticleLife(0.396825,0.476190)
    p:setDirection(-1.570796)
    p:setSpread(6.283185)
    p:setSpeed(166.666656, 300.000000)
    p:setGravity(14.285706,-14.285706)
    p:setRadialAcceleration(514.285767,900.000000)
    p:setTangentialAcceleration(0.000000,14.285706)
    p:setSize(3.125000, 0.031250)
    p:setSizeVariation(0.492063)
    p:setSpin(0.000000, 0.000000)
    p:setSpinVariation(1.000000)
    p:setColor(255,206,105,255,34,32,30,0)
    system.particle=p
    system.blendMode="additive"
    return system
end
-- Use this function for preparing your data, generating local images if you need to, create framebuffers, etc
function loadExplosions()
    idata = love.image.newImageData(32, 32)
    radius = 16
    idata:mapPixel(pixelf)
    small_circle = love.graphics.newImage(idata)
end

-- This function should draw all the explosions that are currently active
function drawExplosions()
  for _,e in ipairs(explosions) do
        love.graphics.setBlendMode(e.blendMode)
        love.graphics.draw(e.particle, 0,0)
  end
end

-- This function should update all explosions - use it for updating the animation, controlling the time they are active, etc
function updateExplosions(dt)
    for i,e in ipairs(explosions) do
        if not e.particle:isEmpty() or e.particle:isActive() then
            e.particle:update(dt)
        else
            e.particle:stop()
            table.remove(explosions, i)
        end
    end
end

-- This function will create a new explosion on coordinates x and y
function newExplosion(x,y)
    local e = boom(small_circle)
    e.particle:setPosition(x,y)
    e.particle:start()
    table.insert(explosions, e)
end
